<?php

namespace Intergo\LaravelAuthMiddleware;

use Illuminate\Contracts\Container\BindingResolutionException;
use Illuminate\Contracts\Http\Kernel;
use Illuminate\Support\ServiceProvider;
use Intergo\LaravelAuthMiddleware\Http\Middleware\Authenticate;

class LaravelAuthMiddlewareServiceProvider extends ServiceProvider
{
    /**
     * Register services.
     */
    public function register(): void
    {
        //
    }

    /**
     * Bootstrap services.
     * @throws BindingResolutionException
     */
    public function boot(): void
    {
        $this->publishes([
            __DIR__.'/../config/auth-middleware.php' => config_path('auth-middleware.php'),
        ]);

        $this->configureMiddleware();
    }

    /**
     * @throws BindingResolutionException
     */
    protected function configureMiddleware(): void
    {
        $kernel = app()->make(Kernel::class);

        $kernel->prependToMiddlewarePriority(Authenticate::class);
    }
}
